-- credits to:
-- HopeASD (NGA qfeizaijun)/ 简繁(NGA zhangzhanxian3)
local addonName, addon = ...
local _
addon[1] = {} -- Gloable
addon[2] = {} -- Function
addon[3] = {} -- Config
addon[4] = {} -- Locale

local G, F, C, L = unpack(addon)

local events = {}

local host = CreateFrame("Frame")
host:SetScript("OnEvent", function(_, event, ...)
	for func in pairs(events[event]) do
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			func(event, CombatLogGetCurrentEventInfo())
		else
			func(event, ...)
		end
	end
end)

function G:RegisterEvent(event, func, unit1, unit2)
	if not events[event] then
		events[event] = {}
		if unit1 then
			host:RegisterUnitEvent(event, unit1, unit2)
		else
			host:RegisterEvent(event)
		end
	end

	events[event][func] = true
end

function G:UnregisterEvent(event, func)
	local funcs = events[event]
	if funcs and funcs[func] then
		funcs[func] = nil

		if not next(funcs) then
			events[event] = nil
			host:UnregisterEvent(event)
		end
	end
end

local DefaultDB = {
	FirstUSE = true;
	Gname = nil,
	cvar = true,
	dbm = true,
	exrt = true,
	skada = true,
	tiny = true,
	mapicon = true,
	ui = true,
	chat = true,
	target = true,
	comb = true,
	syd = true,
	icon = true,
	plate = true,
	arrow = true,
	name = true,
	ct = true,
	unitf = true,
	cast = true,
	castc = true,
	quest = true,
	smap = true,
	mmb = true,
	chatcopy = true,
	chatm = true,
	chatb = true,
	zu = true,
	stop = true,
	mh = true,
	sf = true,
	sq = false,
	debuff = false,
	rtexture =false,
	class = false,
	move = true,
	bc = true,
	jbtext = true,
	centertext = false,
	lfgzq = true,
	myframestyle = false,
	ftip = 1,
	SpellQ = 150
	
}

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("ADDON_LOADED")
eventframe:SetScript("OnEvent",function(self,_,addon)
	if addon ~= "AddUI" then return end
	if not AddUIDB then AddUIDB = {} end
	
		for i, j in pairs(DefaultDB) do
		if type(j) == "table" then
			if AddUIDB[i] == nil then AddUIDB[i] = {} end
			for k, v in pairs(j) do
				if AddUIDB[i][k] == nil then
					AddUIDB[i][k] = v
				end
			end
		else
			if AddUIDB[i] == nil then AddUIDB[i] = j end
		end
	end
	self:UnregisterAllEvents()

end)
local function TestFunc()
SetCVar("SpellQueueWindow", AddUIDB.SpellQ)
end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)



local frame1 = CreateFrame("Frame", nil, InterfaceOptionsFrame, "OptionsBoxTemplate")
frame1.name = addonName

--local frame2 = CreateFrame("Frame", "血条", frame1)
--frame2.name = "血条"
--frame2.parent =  frame1

frame1:SetScript("OnShow", function(frame)
	local clear = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	clear:SetText("恢复默认并重载界面")
	clear:SetWidth(177)
	clear:SetHeight(24)
	clear:SetPoint("TOPLEFT", 442, 25)
	clear:SetScript("OnClick", function()
		AddUIDB = DefaultDB
		ReloadUI()
	end)

	local addui = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	addui:SetPoint("TOPLEFT", 55, -16)
	addui:SetText(addonName)
	addui:SetFont("fonts\\ARHei.ttf", 30, "OUTLINE")

		
	local sm = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	sm:SetPoint("TOPLEFT", 200, -22)
	sm:SetText("重载界面|cff00EE00/aa|r     打开此设置界面|cff00EE00/ad|r\n\n只是一个简单的开关界面,省的去改toc文件了\n|cffFFC0CB需要重载界面才能生效|r,或者退一次游戏\n右击聊天快捷条|cff00EE00世|r按钮可以加入/退出世界频道")
	sm:SetJustifyH("LEFT")
	
	local qqun = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	qqun:SetPoint("BOTTOMRIGHT", -10, 10)
	qqun:SetText("斗鱼:323075\r\rQQ群:718148969")
	qqun:SetJustifyH("RIGHT")
	
	local printhelp = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	printhelp:SetText("斜杠线命令")
	printhelp:SetWidth(177)
	printhelp:SetHeight(24)
	printhelp:SetPoint("TOPLEFT", 16, -55)
	printhelp:SetScript("OnClick", function()
		StaticPopup_Show("printhelp") 
	end)

	local clear = CreateFrame("Button", "AddUISaveButton", frame, "UIPanelButtonTemplate")
	clear:SetText("重载界面")
	clear:SetWidth(177)
	clear:SetHeight(24)
	clear:SetPoint("TOPLEFT", 16, -85)
	clear:SetScript("OnClick", function()
		ReloadUI()
	end)
	
	local function newCheckbox(label, description, onClick)
		local check = CreateFrame("CheckButton", "AddUICheck" .. label, frame, "InterfaceOptionsCheckButtonTemplate")
		check:SetScript("OnClick", function(self)
			local tick = self:GetChecked()
			onClick(self, tick and true or false)
		end)
		check.label = _G[check:GetName() .. "Text"]
		check.label:SetText(label)
		check.tooltipText = description
		--check.tooltipRequirement = description
		return check
	end

	local cvarc = newCheckbox("CVar-锁定一些系统设定","CVar设定,最远视角和社区报错集合石报错优化",function(self, value) AddUIDB.cvar = value end)
	cvarc:SetChecked(AddUIDB.cvar)
	cvarc:SetPoint("TOPLEFT", 16, -120)

	local dbmc = newCheckbox("DBM-自动配置","包括语音包和提示音自动勾选,右侧计时条定位,隐藏小地图按钮",function(self, value) AddUIDB.dbm = value end)
	dbmc:SetChecked(AddUIDB.dbm)
	dbmc:SetPoint("TOPLEFT", 16, -150)
	
	local exrtc = newCheckbox("ExRT-计时器.战复","勾去掉后/EXRT在计时器里面把战斗计时器的勾去掉就可以彻底关闭了",function(self, value) AddUIDB.exrt = value end)
	exrtc:SetChecked(AddUIDB.exrt)
	exrtc:SetPoint("TOPLEFT", 16, -180)
	
	local skadac = newCheckbox("Skada/details配置","自动定位,重载后会回到固定位置,skada还勾选了一些设置,",function(self, value) AddUIDB.skada = value end)
	skadac:SetChecked(AddUIDB.skada)
	skadac:SetPoint("TOPLEFT", 16, -210)
	
	local tinyc = newCheckbox("其他插件自动配置","每次上线自动勾选同一种配置,",function(self, value) AddUIDB.tiny = value end)
	tinyc:SetChecked(AddUIDB.tiny)
	tinyc:SetPoint("TOPLEFT", 16, -240)
	
	local mapiconc = newCheckbox("小地图按钮定位","自动隐藏部分插件的小地图按钮,没隐藏的固定位置",function(self, value) AddUIDB.mapicon = value end)
	mapiconc:SetChecked(AddUIDB.mapicon)
	mapiconc:SetPoint("TOPLEFT", 16, -270)
	
	local uic = newCheckbox("UI缩放锁定","ESC-系统-高级-最下面那个UI缩放",function(self, value) AddUIDB.ui = value end)
	uic:SetChecked(AddUIDB.ui)
	uic:SetPoint("TOPLEFT", 16, -300)
	
	local chatc = newCheckbox("聊天窗口位置锁定","每次上线重设聊天框位置",function(self, value) AddUIDB.chat = value end)
	chatc:SetChecked(AddUIDB.chat)
	chatc:SetPoint("TOPLEFT", 16, -330)
	
	local targetc = newCheckbox("目标头像位置锁定","因为头像加了百分比,不锁定上线会重叠,所以才加了锁定,如需要移动位置可关闭",function(self, value) AddUIDB.target = value end)
	targetc:SetChecked(AddUIDB.target)
	targetc:SetPoint("TOPLEFT", 16, -360)
	
	local combc = newCheckbox("进入脱离战斗提示","屏幕中间上方那个进入脱离战斗提示",function(self, value) AddUIDB.comb = value end)
	combc:SetChecked(AddUIDB.comb)
	combc:SetPoint("TOPLEFT", 16, -390)
	
	local sydc = newCheckbox("角色面板耐久","C键面板装备栏下面的耐久度百分比",function(self, value) AddUIDB.syd = value end)
	sydc:SetChecked(AddUIDB.syd)
	sydc:SetPoint("TOPLEFT", 16, -420)
	
	local iconc = newCheckbox("目标标记按钮","目标头像右边的几个标记按钮",function(self, value) AddUIDB.icon = value end)
	iconc:SetChecked(AddUIDB.icon)
	iconc:SetPoint("TOPLEFT", 16, -450)
	
	local sfc = newCheckbox("Shift焦点","按shift鼠标指向可设置和拖动焦点",function(self, value) AddUIDB.sf = value end)
	sfc:SetChecked(AddUIDB.sf)
	sfc:SetPoint("TOPLEFT", 16, -480)
	
	local info = {}
	local TipDropdown = CreateFrame("Frame", "Tipcursor", frame, "UIDropDownMenuTemplate")
	TipDropdown:SetPoint("TOPLEFT", 0, -515)
	TipDropdown.initialize = function()
		wipe(info)
		local fonts = {1, 0, 2}
		local names = {"跟随", "不跟随", "非战斗跟随"}
		for i, font in next, fonts do
			info.text = names[i]
			info.value = font
			info.func = function(self)
				AddUIDB.ftip = self.value
				TipcursorText:SetText(self:GetText())
			end
			info.checked = font == AddUIDB.ftip
			UIDropDownMenu_AddButton(info)
		end
	end
	TipcursorText:SetText("鼠标跟随方式")
	
	
	local ctc = newCheckbox("滚动战斗记录","LightCT战斗记录插件",function(self, value) AddUIDB.ct = value end)
	ctc:SetChecked(AddUIDB.ct)
	ctc:SetPoint("TOPLEFT", 280, -120)
	
	local unitfc = newCheckbox("头像美化","头像美化和旁边的血量百分比",function(self, value) AddUIDB.unitf = value end)
	unitfc:SetChecked(AddUIDB.unitf)
	unitfc:SetPoint("TOPLEFT", 280, -150)
	
	local castc = newCheckbox("施法条美化","这个施法条是系统自带的去掉了边框放大了",function(self, value) AddUIDB.cast = value end)
	castc:SetChecked(AddUIDB.cast)
	castc:SetPoint("TOPLEFT", 280, -180)
	
	local castcc = newCheckbox("|cff00EE00彩虹施法条|r","需要开启施法条美化",function(self, value) AddUIDB.castc = value end)
	castcc:SetChecked(AddUIDB.castc)
	castcc:SetPoint("TOPLEFT", 280, -210)
	
	local questc = newCheckbox("任务栏美化","任务栏美化",function(self, value) AddUIDB.quest = value end)
	questc:SetChecked(AddUIDB.quest)
	questc:SetPoint("TOPLEFT", 280, -240)
	
	local smapc = newCheckbox("小地图美化","这个关掉的话需要重新进一次游戏才能正常",function(self, value) AddUIDB.smap = value end)
	smapc:SetChecked(AddUIDB.smap)
	smapc:SetPoint("TOPLEFT", 280, -270)
	
	local mmbc = newCheckbox("动作条美化","动作条美化",function(self, value) AddUIDB.mmb = value end)
	mmbc:SetChecked(AddUIDB.mmb)
	mmbc:SetPoint("TOPLEFT", 280, -300)
	
	local chatco = newCheckbox("聊天复制","点击聊天框前+复制当前行,左键复制内容,右键复制全部",function(self, value) AddUIDB.chatcopy = value end)
	chatco:SetChecked(AddUIDB.chatcopy)
	chatco:SetPoint("TOPLEFT", 280, -330)
	
	local chatmc = newCheckbox("聊天窗口美化","聊天窗口美化",function(self, value) AddUIDB.chatm = value end)
	chatmc:SetChecked(AddUIDB.chatm)
	chatmc:SetPoint("TOPLEFT", 280, -360)
	
	local chatbc = newCheckbox("聊天快捷按钮","右击世可以快速加入世界频道!",function(self, value) AddUIDB.chatb = value end)
	chatbc:SetChecked(AddUIDB.chatb)
	chatbc:SetPoint("TOPLEFT", 280, -390)
	
	local zuc = newCheckbox("密语自动邀请","别人密你123或者.组.会自动邀请,支持战网密语",function(self, value) AddUIDB.zu = value end)
	zuc:SetChecked(AddUIDB.zu)
	zuc:SetPoint("TOPLEFT", 280, -420)
	
	local stopc = newCheckbox("打断喊话","打断通报,小队会变小队通报,团队变团队通报",function(self, value) AddUIDB.stop = value end)
	stopc:SetChecked(AddUIDB.stop)
	stopc:SetPoint("TOPLEFT", 280, -450)
	
	local mhc = newCheckbox("自动卖灰","捡破烂自动卖",function(self, value) AddUIDB.mh = value end)
	mhc:SetChecked(AddUIDB.mh)
	mhc:SetPoint("TOPLEFT", 280, -480)
	
	--local bcc = newCheckbox("隐藏动作条边框","如果使用材质建议隐藏",function(self, value) AddUIDB.bc = value end)
	--bcc:SetChecked(AddUIDB.bc)
	--bcc:SetPoint("TOPLEFT", 460, -120)
	
	local movec = newCheckbox("框体移动","如果某些框体突然找不到了可以关闭他重载一下",function(self, value) AddUIDB.move = value end)
	movec:SetChecked(AddUIDB.move)
	movec:SetPoint("TOPLEFT", 460, -120)
	
	local debuffc = newCheckbox("显示所有debuff","显示目标头像所有debuff",function(self, value) AddUIDB.debuff = value end)
	debuffc:SetChecked(AddUIDB.debuff)
	debuffc:SetPoint("TOPLEFT", 460, -150)
	
	local rtexturec = newCheckbox("团队扁平材质","团队框架材质扁平化",function(self, value) AddUIDB.rtexture = value end)
	rtexturec:SetChecked(AddUIDB.rtexture)
	rtexturec:SetPoint("TOPLEFT", 460, -180)
	
	local classc = newCheckbox("头像职业图标","用职业图标代替头像",function(self, value) AddUIDB.class = value end)
	classc:SetChecked(AddUIDB.class)
	classc:SetPoint("TOPLEFT", 460, -210)
	
	local sqc = newCheckbox("快速拾取","增加拾取速度",function(self, value) AddUIDB.sq = value end)
	sqc:SetChecked(AddUIDB.sq)
	sqc:SetPoint("TOPLEFT", 460, -240)
	
	local jbtextc = newCheckbox("法术警报倒数","触发buff自带的那个括号上显示buff剩余时间",function(self, value) AddUIDB.jbtext = value end)
	jbtextc:SetChecked(AddUIDB.jbtext)
	jbtextc:SetPoint("TOPLEFT", 460, -270)
	
	local hptextc = newCheckbox("中间生命值百分比","中间人物下方显示生命值百分比大数字",function(self, value) AddUIDB.centertext = value end)
	hptextc:SetChecked(AddUIDB.centertext)
	hptextc:SetPoint("TOPLEFT", 460, -300)
	
	local myframec = newCheckbox("自己头像方形","改变自己头像样式",function(self, value) AddUIDB.myframestyle = value end)
	myframec:SetChecked(AddUIDB.myframestyle)
	myframec:SetPoint("TOPLEFT", 460, -330)
	
		local function newSlider(SliderName, x, y, minValue, maxValue, curValue, valueStep, lowText, highText, upText, tipText, varformat)
		local pSlider = CreateFrame("Slider", "Slider"..SliderName , frame, "OptionsSliderTemplate" );
		pSlider:SetPoint("TOPLEFT", frame, "TOPLEFT", x, y);
		pSlider:SetMinMaxValues(minValue, maxValue);
		pSlider:SetValue(curValue);
		pSlider:SetValueStep(valueStep);
		pSlider:SetObeyStepOnDrag(true);
		pSlider.textLow = _G["Slider"..SliderName.."Low"]
		pSlider.textHigh = _G["Slider"..SliderName.."High"]
		pSlider.text = _G["Slider"..SliderName.."Text"]
		pSlider.textLow:SetText(lowText)
		pSlider.textHigh:SetText(highText)
		pSlider.text:SetText("|cffFFD700"..upText.." :  "..string.format(varformat,pSlider:GetValue()).."|r")

		pSlider:SetScript("OnValueChanged", 
		function(pSlider,event,arg1) 
			pSlider.text:SetText("|cffFFD700"..upText.." :  "..string.format(varformat,pSlider:GetValue()).."|r")
		end)
		pSlider.tooltipText = tipText
		-- body
		return pSlider
	end
	
	frame.Spell = newSlider("Spell", 280, -525, 0, 400, 400, 1, " ", " ", "施法序列延迟", "施法序列延迟","%d")
	frame.Spell:SetValue(AddUIDB.SpellQ)
	frame.Spell:HookScript("OnValueChanged", function(self, value)
		AddUIDB.SpellQ = tonumber(string.format("%d",self:GetValue()))
		SetCVar("SpellQueueWindow", AddUIDB.SpellQ) 
	end)
	
	frame:SetScript("OnShow", nil)
	
	--frame.okay = function(frame)
	--		ReloadUI()
	--end
end)

InterfaceOptions_AddCategory(frame1)
--InterfaceOptions_AddCategory(frame2)
SLASH_ADDUI1 = "/ad"
SLASH_ADDUI2 = "/add"
SLASH_ADDUI3 = "/addui"
SlashCmdList["ADDUI"] = function() 
    InterfaceOptionsFrame_OpenToCategory(frame1)
	InterfaceOptionsFrame_OpenToCategory(frame1)
end